Subject: bug#44254: Performance of package input rewriting

From: zimoun <[email-masked]>
Date: Tue, 27 Oct 2020 15:14:22 +0100

Hi Lars,

On Tue, 27 Oct 2020 at 14:26, Lars-Dominik Braun <[email-masked]> wrote:

> Previously I have been doing this using package-input-rewriting, but starting
> an environment containing python-jupyterlab alone took about 20s (warm caches,
> all derivations in the store). Manually rewriting inputs by inheriting and
> alist-delete’ing brings this down to 3s, which is pretty significant.
> --no-grafts has not much of an impact (15s vs 2s) here. See
> https://github.com/guix-science/guix-science/commit/972795a23cc9eb5a0bb1a2ffb5681d151fc4d4b0
> for the exact changes.

Is it not related to “#:deep? #t“ by default?  The default was #f.

Well, using ’inherit’ only rewrites the direct explicit dependencies.
However, ’package-input-rewriting’ traverse all the graph of
dependencies and replaces accordingly.  Maybe I misunderstand.

All the best,
simon